function maxIndexVector = identifyMaximaSlidingWindow(dataVector, windowSize)
% find maxima in periodic data
%
% The idea is to slide a window over the periodic data and count the times
%   for which certain values are the maximum in the window.
%
% THIS IS NO USER FUNCTION

% The elk-library: convex geometry applied to crystallization modeling.
%   Copyright (C) 2013 Alexander Reinhold
%
% This program is free software: you can redistribute it and/or modify it 
%   under the terms of the GNU General Public License as published by the 
%   Free Software Foundation, either version 3 of the License, or (at your 
%   option) any later version.
%
% This program is distributed in the hope that it will be useful, but 
%   WITHOUT ANY WARRANTY; without even the implied warranty of 
%   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU 
%   General Public License for more details.
%
% You should have received a copy of the GNU General Public License along 
%   with this program.  If not, see <http://www.gnu.org/licenses/>.

% add a tiny noise to avoid multiple similar edges
dataVector = dataVector + rand(size(dataVector))*max(dataVector)*1e-10;

nData = length(dataVector);
filterVector = true(size(dataVector));
for iPos = 1:nData
    indexVector = iPos:(iPos+windowSize-1);
    indexVector = mod(indexVector - 1, nData) + 1;
    filterVector(indexVector) = filterVector(indexVector) & ...
        (dataVector(indexVector) == max(dataVector(indexVector)));
end

maxIndexVector = find(filterVector);